import os.path
from os.path import join,dirname,realpath

import requests, pickle, re
import json
import sqlite3
from datetime import datetime
import csv
import pandas as pd
import concurrent.futures
from concurrent.futures import ThreadPoolExecutor, as_completed
import time
import sys
import traceback
# from time import time
import random
from bs4 import BeautifulSoup
import urllib.parse as urlparse
from urllib.parse import parse_qs
import mysql
from mysql.connector import connect, Error
import urllib.request
import urllib.parse
from app.config.environment import configuration

def create_connection():
    db_file = join(dirname(realpath(__file__)),"scrappers.db")
    conn = None
    try:
        conn = sqlite3.connect(db_file)
        print(sqlite3.version)
    except Error as e:
        print(e)
    return conn


def getProxy():
    conn = create_connection()
    cur = conn.cursor()
    cur.execute("SELECT * FROM proxys ORDER BY RANDOM() LIMIT 1;")

    proxy_details = cur.fetchall()
    conn.close()
    proxy_ip = proxy_details[0][1]
    print(proxy_ip)

    port = proxy_details[0][2]
    print(port)

    user = proxy_details[0][3]
    print(user)

    password = proxy_details[0][4]
    print(password)

    proxy_url = "http://" + user + ":" + password + "@" + proxy_ip + ":" + port
    print(proxy_url)

    return proxy_url


def getSuggestedProperties(cn_hotel_name,retry_count=0):
    try:
        headers = {
            'authority': 'www.trip.com',
            'sec-ch-ua': '"Chromium";v="88", "Google Chrome";v="88", ";Not A Brand";v="99"',
            'dnt': '1',
            'sec-ch-ua-mobile': '?0',
            'user-agent': 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/88.0.4324.182 Safari/537.36',
            'content-type': 'application/json',
            'accept': '*/*',
            'origin': 'https://www.trip.com',
            'sec-fetch-site': 'same-origin',
            'sec-fetch-mode': 'cors',
            'sec-fetch-dest': 'empty',
            'referer': 'https://www.trip.com/',
            'accept-language': 'en-GB,en-US;q=0.9,en;q=0.8',
            # 'cookie': 'ibu_online_home_language_match={"isFromTWNotZh":false,"isFromIPRedirect":false,"isFromLastVisited":false,"isRedirect":false,"isShowSuggestion":false,"lastVisited":""}; ibulanguage=EN; cookiePricesDisplayed=USD; _abtest_userid=56efd79f-a998-4386-bebc-ff6bcdc3ba90; _tp_search_latest_channel_name=hotels; _gid=GA1.2.1730211434.1614690565; _gcl_au=1.1.651753055.1614690566; _RF1=103.104.87.188; _RSG=ViKtBsipiTE50RisI1iIL8; _RDG=28882c7b187f18213a152e50a3af567e22; _RGUID=e76ccecd-8bdd-4b1f-8552-b014b6b1b005; IBU_TRANCE_LOG_P=64369939236; IBU_TRANCE_LOG_URL=%2Fhotels%2Fcityname-hotel-detail-736041%2Fhotelname%2F; librauuid=OT9h2AkZoNscuXm5; ibulocale=en_us; __utma=1.1660558809.1614690565.1614690798.1614690798.1; __utmc=1; __utmz=1.1614690798.1.1.utmcsr=(direct)|utmccn=(direct)|utmcmd=(none); g_state={"i_p":1614698180304,"i_l":1}; ibu_online_permission_cls_ct=1; ibu_online_permission_cls_gap=1614691027654; intl_ht1=h4%3D338_2133891%2C26282_736041; hotel=2133891; _uetsid=075ee2c07b5911eb957c95a86a7d0e01; _uetvid=075f5fd07b5911ebb493eb658fcd3d01; _bfa=1.1614690565431.43j274.1.1614690565431.1614694764843.2.20; _bfs=1.2; _gat=1; _gat_UA-109672825-3=1; _dc_gtm_UA-109672825-4=1; _ga_X437DZ73MR=GS1.1.1614694764.2.1.1614695213.0; _ga=GA1.1.1660558809.1614690565; _bfi=p1%3D10320668088%26p2%3D10320668088%26v1%3D20%26v2%3D19',
        }

        data = '{"keyword":"' + cn_hotel_name + '","label":"","searchType":"D","cityId":0,"district":0,"province":0,"head":{"Locale":"en_us","Currency":"USD","P":"","Union":{"aid":"","sid":""},"TimeZone":"+5","Version":"","WebpSupport":true,"userRegion":"us","ticket":"","HotelExtension":{"hasAidInUrl":false},"PageId":"","device":"PC"}}'

        proxy = getProxy()
        response = requests.post('https://www.trip.com/restapi/soa2/16709/json/gaHotelSearchEngine', headers=headers,
                                 data=data, proxies={'https': proxy})
        print(response.status_code)
        if response.status_code == 200:
            response = response.json()
            response_status = response['ResponseStatus']
            if response_status['Ack'] == "Success":
                search_results = response['Response']
                if 'searchResults' in search_results:
                    if len(search_results) > 0:
                        suggestions = search_results['searchResults']
                        return suggestions
        else:
            if retry_count < 5:
                retry_count = retry_count+1
                return getSuggestedProperties(cn_hotel_name,retry_count)
    except Exception as ex:
        track = traceback.format_exc()
        print(track)


def checkSimilarity(cn_data, expedia_data):
    try:
        is_similar = False
        st_api_url = "http://209.97.151.98/api/check_similarity"
        headers = {
            "Content-Type": "application/json"
        }
        body = {
            'data': cn_data,
            'source': expedia_data
        }
        body = json.dumps(body)
        # body = json.dumps(body)
        response = requests.post(st_api_url, headers=headers, data=body)
        if response.status_code == 200:
            response = response.json()
            similarity_data = response['data']
            avg_similarity = similarity_data['avg_similarity']
            distance = similarity_data['distance'].replace('km', '').strip()
            distance = float(distance)
            title_similarity = similarity_data['name']

            print("Average Similarity : " + str(avg_similarity))
            print("Distance : " + str(distance))
            print("Title Similarity : " + str(title_similarity))

            if avg_similarity >= 90 and distance <= 2.5:
                is_similar = True

        return is_similar
    except Exception as ex:
        print(str(ex))


def getMatchedProperty(cn_hotel_name, cn_city_name, cn_latitude, cn_longitude, suggested_properties):
    try:
        for suggested_property in suggested_properties:
            trip_hotel_id = suggested_property['id']
            trip_hotel_type = suggested_property['type']
            trip_hotel_city_name=suggested_property['cityName']
            trip_hotel_city_id = suggested_property['cityId']
            trip_hotel_name = suggested_property['displayName']
            trip_hotel_lat = suggested_property['lat']
            trip_hotel_lon = suggested_property['lon']

            cn_data = {
                'name': cn_hotel_name,
                'lat': cn_latitude,
                'long': cn_longitude,
                'source': 'cn',
                'city': cn_city_name
            }

            trip_data = {
                'name': trip_hotel_name,
                'lat': trip_hotel_lat,
                'long': trip_hotel_lon,
                'source': 'trip'
            }



            is_similar = checkSimilarity(cn_data, trip_data)
            print(is_similar)
            if is_similar:
                return {
                    'trip_hotel_id':trip_hotel_id,
                    'trip_hotel_name': trip_hotel_name,
                    'trip_hotel_city_name':trip_hotel_city_name,
                    'trip_hotel_city_id': trip_hotel_city_id,
                    'trip_hotel_lat': trip_hotel_lat,
                    'trip_hotel_lon': trip_hotel_lon
                }
            else:
                return False
    except Exception as ex:
        track = traceback.format_exc()
        print(track)

def getHotelReviews(hotel_id,hotel_name,city_name,city_id,retry_count=0):
    try:
        hotel_name = hotel_name.replace('-', '').replace(' ', '-').lower()
        city_name = city_name.lower()
        hotel_landing_page_url = "https://www.trip.com/hotels/" + city_name + "-hotel-detail-" + str(
            hotel_id) + "/" + hotel_name + "/?cityId=" + str(city_id)
        print("Landing Page URL : " + hotel_landing_page_url)

        headers = {
            'authority': 'www.trip.com',
            'sec-ch-ua': '"Chromium";v="88", "Google Chrome";v="88", ";Not A Brand";v="99"',
            'dnt': '1',
            'sec-ch-ua-mobile': '?0',
            'user-agent': 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/88.0.4324.182 Safari/537.36',
            'content-type': 'application/json',
            'accept': 'application/json',
            'p': '',
            'pid': '',
            'origin': 'https://www.trip.com',
            'sec-fetch-site': 'same-origin',
            'sec-fetch-mode': 'cors',
            'sec-fetch-dest': 'empty',
            'referer': hotel_landing_page_url,
            'accept-language': 'en-GB,en-US;q=0.9,en;q=0.8',
            # 'cookie': 'ibu_online_home_language_match={"isFromTWNotZh":false,"isFromIPRedirect":false,"isFromLastVisited":false,"isRedirect":false,"isShowSuggestion":false,"lastVisited":""}; ibulanguage=EN; cookiePricesDisplayed=USD; _abtest_userid=56efd79f-a998-4386-bebc-ff6bcdc3ba90; _tp_search_latest_channel_name=hotels; _gid=GA1.2.1730211434.1614690565; _gcl_au=1.1.651753055.1614690566; _RF1=103.104.87.188; _RSG=ViKtBsipiTE50RisI1iIL8; _RDG=28882c7b187f18213a152e50a3af567e22; _RGUID=e76ccecd-8bdd-4b1f-8552-b014b6b1b005; IBU_TRANCE_LOG_P=64369939236; IBU_TRANCE_LOG_URL=%2Fhotels%2Fcityname-hotel-detail-736041%2Fhotelname%2F; ibulocale=en_us; __utma=1.1660558809.1614690565.1614690798.1614690798.1; __utmc=1; __utmz=1.1614690798.1.1.utmcsr=(direct)|utmccn=(direct)|utmcmd=(none); g_state={"i_p":1614698180304,"i_l":1}; ibu_online_permission_cls_ct=1; ibu_online_permission_cls_gap=1614691027654; intl_ht1=h4%3D338_732584%2C338_2133891%2C26282_736041; hotel=732584; hotelhst=1164390341; _bfa=1.1614690565431.43j274.1.1614703515354.1614712771003.4.27; _bfs=1.3; _gat_UA-109672825-3=1; _dc_gtm_UA-109672825-4=1; _uetsid=075ee2c07b5911eb957c95a86a7d0e01; _uetvid=075f5fd07b5911ebb493eb658fcd3d01; _ga=GA1.2.1660558809.1614690565; _gat_UA-109672825-4=1; _bfi=p1%3D10320668147%26p2%3D10320668147%26v1%3D27%26v2%3D26; _ga_X437DZ73MR=GS1.1.1614712771.4.1.1614712907.0; librauuid=OT9h2AkZoNscuXm5',
        }

        data = '{"PageNo":1,"PageSize":10,"MasterHotelId":' + hotel_id + ',"NeedFilter":true,"UnUsefulPageNo":1,"UnUsefulPageSize":5,"isHasFold":false,"Head":{"Locale":"en-US","Currency":"USD","AID":"","SID":"","ClientID":"","OUID":"","CAID":"","CSID":"","COUID":"","TimeZone":"5","PageID":"","HotelExtension":{"WebpSupport":true,"Qid":"","hasAidInUrl":false,"group":"TRIP","PID":""},"Frontend":{"vid":"","sessionID":"","pvid":""},"P":"","Device":"PC","Version":"0"}}'

        proxy = getProxy()
        response = requests.post('https://www.trip.com/restapi/soa2/16709/json/GetReviewList', headers=headers,
                                 data=data, proxies={'https': proxy})
        if response.status_code == 200:
            # print(response.text)
            # exit()
            response = response.json()
            response_status = response['ResponseStatus']
            if response_status['Ack'] == "Success":
                review_data = response['Response']
                review_base_info = review_data['ReviewBaseInfo']
                review_score = review_base_info['score'] if 'score' in review_base_info else ''

                review_tag = review_base_info['scoreDesc'] if 'scoreDesc' in review_base_info else ''
                review_tag = review_tag.lower()
                total_reviews = 0

                if 'allTotalReviews' in review_base_info:
                    total_reviews = total_reviews + int(review_base_info['allTotalReviews'])

                if 'BookingReview' in review_data:
                    booking_reviews = review_data['BookingReview']
                    if 'count' in booking_reviews:
                        booking_review_count = booking_reviews['count']
                        total_reviews = total_reviews + booking_review_count


                return {
                    'trip_review_score': review_score,
                    'trip_review_tag': review_tag,
                    'trip_total_reviews': total_reviews
                }
        else:
            if retry_count < 5:
                return getHotelReviews(hotel_id,hotel_name,city_name,city_id,retry_count)
            return False
    except Exception as ex:
        track = traceback.format_exc()
        print(track)

def getReviewsFromTrip(cn_property_id, cn_hotel_name, city_name, cn_latitude, cn_longitude):
    try:
        proxy = getProxy()
        print()
        suggested_properties = getSuggestedProperties(cn_hotel_name, proxy)

        if suggested_properties:
            matched_hotel = getMatchedProperty(cn_hotel_name, city_name, cn_latitude, cn_longitude, suggested_properties)
            print(matched_hotel)

            if matched_hotel:
                hotel_reviews = getHotelReviews(matched_hotel['trip_hotel_id'], matched_hotel['trip_hotel_name'],
                                                matched_hotel['trip_hotel_city_name'], matched_hotel['trip_hotel_city_id'],
                                                proxy)

                if hotel_reviews:
                    if float(hotel_reviews['trip_review_score']) > 0:
                        return {
                            'trip_review_score':float(hotel_reviews['trip_review_score']),
                            'trip_review_tag':hotel_reviews['trip_review_tag'],
                            'trip_total_reviews':int(hotel_reviews['trip_total_reviews'])
                        }
        return False
    except Exception as ex:
        track=traceback.format_exc()
        return False


def dbConnect():
    try:
        connection = mysql.connector.connect(
            host=configuration.db_host,
            user=configuration.db_user,
            password=configuration.db_password,
            database=configuration.db_database
        )
        return connection
    except Error as e:
        print(e)
def getCityHotelsFromDB(city,state,country):
    connection  = dbConnect()
    # query ="select * from cn_grs.fc_product_hotel_reviews where (source = 'ratehawk' or source = 'ctrips' or source = 'lci') and city in ('Las Vegas', 'London', 'Dubai', 'Amsterdam', 'Paris', 'Singapore', 'Barcelona', 'Bangkok', 'Prague', 'Hong Kong', 'Lisbon', 'Hollywood', 'Chicago', 'New Orleans', 'San Francisco', 'Orlando', 'Miami', 'Edinburgh', 'Dublin', 'Los Angeles', 'Boston', 'Washington DC', 'Rome', 'Jaipur', 'Tokyo', 'Seattle', 'Berlin', 'Delhi', 'Mumbai', 'Atlanta', 'Toronto', 'Philadelphia', 'Istanbul', 'Hamburg', 'Honolulu', 'Cape Town', 'Chennai', 'Dallas', 'Abu Dhabi', 'Vancouver', 'Venice', 'Budapest', 'Sydney', 'Vienna', 'Manila', 'Madrid', 'Houston', 'Colombo', 'Agra', 'Kuala Lumpur', 'New York', 'Brussels', 'Copenhagen', 'Pattaya', 'Munich', 'Athens', 'Melbourne', 'Santorini', 'Cairo', 'Iceland', 'Seoul', 'Milan', 'Florence', 'Stockholm', 'Johannesburg', 'Beirut', 'Cebu City', 'Kyoto', 'Auckland', 'Dubrovnik', 'Chiang Mai', 'Amman', 'Nice', 'Shanghai', 'Taipei', 'Mexico City', 'Boracay', 'Hanoi', 'Geneva', 'Osaka', 'Jerusalem', 'Moscow', 'Porto', 'Antalya', 'Hurghada', 'Rio de Janeiro', 'Costa Rica', 'Krabi', 'Split ', 'Ho Chi Minh City', 'Warsaw', 'Jakarta', 'Buenos Aires', 'Phnom Penh', 'Macau', 'Casablanca', 'Sofia', 'Johor Bahru', 'Zagreb', 'Shenzhen', 'Da Nang') order by city ASC limit "+str(limit)+" offset "+str(offset)
    query= "select * from cn_grs.fc_product_hotel_reviews where (source = 'ratehawk' or source = 'ctrips' or source = 'lci' or source='rakuteen') and city LIKE \"%"+str(city)+"%\" and state=\""+str(state)+"\" and country = \""+str(country)+"\""
    cursor = connection.cursor(buffered=True)
    cursor.execute(query)
    results = cursor.fetchall()
    connection.close()
    return results

def isNaN(string):
    return string != string


def getHotelById(product_id):
    connection  = dbConnect()
    # query ="select * from cn_grs.fc_product_hotel_reviews where (source = 'ratehawk' or source = 'ctrips' or source = 'lci') and city in ('Las Vegas', 'London', 'Dubai', 'Amsterdam', 'Paris', 'Singapore', 'Barcelona', 'Bangkok', 'Prague', 'Hong Kong', 'Lisbon', 'Hollywood', 'Chicago', 'New Orleans', 'San Francisco', 'Orlando', 'Miami', 'Edinburgh', 'Dublin', 'Los Angeles', 'Boston', 'Washington DC', 'Rome', 'Jaipur', 'Tokyo', 'Seattle', 'Berlin', 'Delhi', 'Mumbai', 'Atlanta', 'Toronto', 'Philadelphia', 'Istanbul', 'Hamburg', 'Honolulu', 'Cape Town', 'Chennai', 'Dallas', 'Abu Dhabi', 'Vancouver', 'Venice', 'Budapest', 'Sydney', 'Vienna', 'Manila', 'Madrid', 'Houston', 'Colombo', 'Agra', 'Kuala Lumpur', 'New York', 'Brussels', 'Copenhagen', 'Pattaya', 'Munich', 'Athens', 'Melbourne', 'Santorini', 'Cairo', 'Iceland', 'Seoul', 'Milan', 'Florence', 'Stockholm', 'Johannesburg', 'Beirut', 'Cebu City', 'Kyoto', 'Auckland', 'Dubrovnik', 'Chiang Mai', 'Amman', 'Nice', 'Shanghai', 'Taipei', 'Mexico City', 'Boracay', 'Hanoi', 'Geneva', 'Osaka', 'Jerusalem', 'Moscow', 'Porto', 'Antalya', 'Hurghada', 'Rio de Janeiro', 'Costa Rica', 'Krabi', 'Split ', 'Ho Chi Minh City', 'Warsaw', 'Jakarta', 'Buenos Aires', 'Phnom Penh', 'Macau', 'Casablanca', 'Sofia', 'Johor Bahru', 'Zagreb', 'Shenzhen', 'Da Nang') order by city ASC limit "+str(limit)+" offset "+str(offset)
    query= "select * from cn_grs.fc_product_hotel_reviews where product_id = "+str(product_id)
    cursor = connection.cursor(buffered=True)
    cursor.execute(query)
    results = cursor.fetchone()
    connection.close()
    return results

