import os.path
from os.path import join,dirname,realpath
import requests,pickle,re
import json
import sqlite3
from datetime import datetime
from sqlite3 import Error
import csv
import pandas as pd
import concurrent.futures
from concurrent.futures import ThreadPoolExecutor, as_completed
import time
import sys
# from time import time
import random
from bs4 import BeautifulSoup
import urllib.parse as urlparse
from urllib.parse import parse_qs
import traceback
import mysql
from mysql.connector import connect,Error
import threading
import urllib.request
import urllib.parse
# from app.config.environment import configuration

def replace_diacritic(name):
    """
    Function to replace string special characters
    name: input string
    output: string with ascii charaters and lower form
    """
    name = str(name)
    mapping = {"À":"a","Á":"a","Â":"a","Ã":"a","Ä":"a","Å":"a","Æ":"a","Ç":"c","È":"e",
    "É":"e","Ê":"e","Ë":"e","Ì":"i","Í":"i","Î":"i","Ï":"i","Ð":"e","Ñ":"n","Ò":"o",
    "Ó":"o","Ô":"o","Õ":"o","Ö":"o","Ø":"o","Ù":"u","Ú":"u","Û":"u","Ü":"u","Ý":"y",
    "Þ":"p","ß":"s","à":"a","á":"a","â":"a","ã":"a","ä":"a","å":"a","æ":"a","ç":"c",
    "è":"e","é":"e","ê":"e","ë":"e","ì":"i","í":"i","î":"i","ï":"i","ð":"e","ñ":"n",
    "ò":"o","ó":"o","ô":"o","õ":"o","ö":"o","ø":"o","ù":"u","ú":"u","û":"u","ü":"u",
    "ý":"y","þ":"p","ÿ":"y","Ā":"a","ā":"a","Ă":"a","ă":"a","Ą":"a","ą":"a","Ć":"c",
    "ć":"c","Ĉ":"c","ĉ":"c","Ċ":"c","ċ":"c","Č":"c","č":"c","Ď":"d","ď":"d","Đ":"d",
    "đ":"d","Ē":"e","ē":"e","Ĕ":"e","ĕ":"e","Ė":"e","ė":"e","Ę":"e","ę":"e","Ě":"e",
    "ě":"e","Ĝ":"g","ĝ":"g","Ğ":"g","ğ":"g","Ġ":"g","ġ":"g","Ģ":"g","ģ":"g","Ĥ":"h",
    "ĥ":"h","Ħ":"h","ħ":"h","Ĩ":"i","ĩ":"i","Ī":"i","ī":"i","Ĭ":"i","ĭ":"i","Į":"i",
    "į":"i","İ":"i","ı":"i","Ĳ":"i","ĳ":"i","Ĵ":"j","ĵ":"j","Ķ":"k","ķ":"k","ĸ":"k",
    "Ĺ":"l","ĺ":"l","Ļ":"l","ļ":"l","Ľ":"l","ľ":"l","Ŀ":"l","ŀ":"l","Ł":"l","ł":"l",
    "Ń":"n","ń":"n","Ņ":"n","ņ":"n","Ň":"n","ň":"n","ŉ":"n","Ŋ":"n","ŋ":"n","Ō":"o",
    "ō":"o","Ŏ":"o","ŏ":"o","Ő":"o","ő":"o","Œ":"o","œ":"o","Ŕ":"r","ŕ":"r","Ŗ":"r",
    "ŗ":"r","Ř":"r","ř":"r","Ś":"s","ś":"s","Ŝ":"s","ŝ":"s","Ş":"s","ş":"s","Š":"s",
    "š":"s","Ţ":"t","ţ":"t","Ť":"t","ť":"t","Ŧ":"t","ŧ":"t","Ũ":"u","ũ":"u","Ū":"u",
    "ū":"u","Ŭ":"u","ŭ":"u","Ů":"u","ů":"u","Ű":"u","ű":"u","Ų":"u","ų":"u","Ŵ":"w",
    "ŵ":"w","Ŷ":"y","ŷ":"y","Ÿ":"y","Ź":"z","ź":"z","Ż":"z","ż":"z","Ž":"z","ž":"z",
    "ſ":"s"}
    updated_name = ''
    for i in range(len(name)):
        if name[i] in mapping.keys():
            updated_name += mapping[name[i]]
        else:
            updated_name += name[i]
    updated_name = updated_name.lower()
    return updated_name

def create_connection():
    print(os.path.dirname(os.path.realpath('__file__')))
    db_file = join(dirname(realpath(__file__)),"scrappers.db")
    conn = None
    try:
        conn = sqlite3.connect(db_file)
        print(sqlite3.version)
    except Error as e:
        print(e)
    return conn


def getProxies():
    proxies={}
    conn=create_connection()
    cur = conn.cursor()
    cur.execute("SELECT * FROM proxys;")

    proxy_details = cur.fetchall()
    conn.close()
    proxy_set=[]
    proxy_count = 0
    proxy_url=""
    for proxy in proxy_details:
        proxy_count = proxy_count+1
        proxy_ip = proxy[1]
        port = proxy[2]
        user = proxy[3]
        password = proxy[4]
        proxy_url = "http://"+user+':'+password+"@"+proxy_ip+":"+port
        proxy_set.insert(proxy_count,proxy_url)
    proxy_string = ','.join(proxy_set)

    proxies = {'http':proxy_string}
    return proxies

def getAddressFromGoogle(city,state,country):
    try:
        proxies= getProxies()
        address = str(city) + "+" + str(country)
        url = "https://maps.googleapis.com/maps/api/geocode/json?key=AIzaSyCJhD4c4t_X02mk2ViGl-6QnYQN_KqdHZ8&language=en&address="+address
        response = requests.get(url,proxies=proxies)
        print("Status Code : "+ str(response.status_code))
        if response.status_code == 200:
            response = response.json()
            # print(response['results'])
            search_results = response['results']
            for result in search_results:
                labels_length = len(result['formatted_address'])
                label = result['formatted_address']
                # dest_type = str(result['dest_type'])
                
                google_city_lat=float(result['geometry']['location']['lat'])
                google_city_lon=float(result['geometry']['location']['lng'])
                google_city = ''
                google_country = ''
                google_state = ''
                try:
                    google_city = result['address_components'][0]['long_name']
                    checkLength = len(result['address_components'])
                    print(checkLength)
                    if checkLength == 3:
                        google_state = result['address_components'][1]['long_name']
                        google_country = result['address_components'][2]['long_name']
                    else:
                        google_country = result['address_components'][1]['long_name']
                except Exception as ex:
                    pass

                google_place_id = result['place_id']
                # booking_city_id =''
                # booking_neighborhood_name = ''
                label = result['formatted_address']

                if google_city_lat and google_city_lon:
                    print("label : "+label)
                    print("Google City Name : "+ google_city)
                    print("Google State Name:"+google_state)
                    print("Google Country Name:"+google_country)
                    print("Google Latitude : "+str(google_city_lat))
                    print("Goole Longitude : "+str(google_city_lon))
                    return{
                        'label':label,
                        'google_place_id':google_place_id,
                        'google_city_name':google_city,
                        'google_state_name':google_state,
                        'google_country_name':google_country,
                        'google_city_lat':google_city_lat,
                        'google_city_lon':google_city_lon,
                        'google_location_type':'location'
                    }
                else:
                    return False
    except Exception as ex:
        track = traceback.format_exc()
        print(str(track))
        exit()

def isNaN(string):
    return string != string

def addCitiesInDataFile(data):
    with open(r'missing_states_from_google.csv', 'a', newline='') as csvfile:
        fields = ['city','state','country','google_city','google_state','google_country','lat','lon','label']
        writer = csv.DictWriter(csvfile, fieldnames=fields)
        writer.writerow(data)
        print("City Details Addedd In CSV FILE")
        print("----------------------------------")

def getCrawledCitiesCoordinates():
    city_inventory = pd.read_csv(r'../missing_states.csv')
    city_inventory_download = city_inventory
    # city_inventory.sort_values(by='LISTINGS_COUNT', ascending=False)
    ignored_keywords = ["city","of","the","special","capital","district","province","region"]
    for index, rowIndex in city_inventory.iterrows():
        number = index
        req = {}
        row = {}
        final_city = ""
        city = str(rowIndex[2])
        raw = city.split(" ")
        for i in raw:
            if i.lower() not in ignored_keywords:
                final_city += i + " "
        row = {}
        row['country'] = rowIndex['country']
        try:
            print(isNaN(rowIndex['city']))
            if isNaN(rowIndex['city']):
                if isNaN(rowIndex['state']):
                    city = str(rowIndex['country'])
                    row['city'] = city
                    row['state'] = ''
                else:
                    city = str(rowIndex['state'])
                    row['city'] = city
                    row['state'] = ''
            else:
                city = rowIndex['state']
                row['city'] = replace_diacritic(final_city)
                row['state'] = ''
        except Exception as e:
            print(e)
        try:
            print(row)
            autosuggest_response = getAddressFromGoogle(row['city'],row['state'],row['country'])
            # exit()
            if autosuggest_response:
                row['label'] = autosuggest_response['label']
                row['google_city'] = autosuggest_response['google_city_name']
                row['google_state'] = autosuggest_response['google_state_name']
                row['google_country'] = autosuggest_response['google_country_name']
                row['lat'] = autosuggest_response['google_city_lat']
                row['lon'] = autosuggest_response['google_city_lon']
                addCitiesInDataFile(row)
                city_inventory_download = city_inventory_download.drop(index = index)
            else:
                print("No Match Found From Google For This City")
        except Exception as e:
            print(e)
    print("Completed")
    city_inventory_download.to_csv("remaining_states_from_google.csv")

getCrawledCitiesCoordinates()

