import pandas as pd
import csv
import traceback

top_cities = pd.read_csv('./top_grs_cities.csv')
top_cities = top_cities.City

cities_with_inventory = pd.read_csv('./cities_with_inventory.csv')
cities_with_inventory = cities_with_inventory[['COUNTRY','STATE','CITY','LISTINGS_COUNT']]
cities_with_inventory.head()
# print(cities_with_inventory)
# exit()

for top_city in top_cities:
    print("City Selected : "+top_city)
    matched_suggestions = cities_with_inventory[cities_with_inventory['CITY'].astype(str).str.contains(top_city)]
    
    if len(matched_suggestions) > 0:
        for index,suggestion in matched_suggestions.iterrows():
            print("Matched City : "+str(suggestion['CITY']))
            print("State : "+str(suggestion['STATE']))
            print("Country : "+str(suggestion['COUNTRY']))
            print("Listings Count : "+str(suggestion['LISTINGS_COUNT']))
            with open(r'./grs_city_suggestions.csv','a',newline='') as csvfile:
                try:
                    fieldnames=[
                        'top_city_given',
                        'city_matched',
                        'state',
                        'country',
                        'inventory_count'
                    ]

                    writer = csv.DictWriter(csvfile,fieldnames=fieldnames)
                    writer.writerow({
                        'top_city_given':top_city,
                        'city_matched':suggestion['CITY'],
                        'state':suggestion['STATE'],
                        'country':suggestion['COUNTRY'],
                        'inventory_count':suggestion['LISTINGS_COUNT']
                    })

                except Exception as ex:
                    track = traceback.format_exc()
                    print(str(track))