import pandas as pd
import csv
import  traceback

# Booking Range : 1-10
# Hotels Range : 1-10
# Agoda Range : 1-10
# Expedia Range : 1-5
# Trip Range : 1-5

# Adjectives
# 3 OK
# 3.5 Good
# 4 Very good
# 4.5 Wonderful
# 5 Exceptional

def isNaN(string):
    return string != string
def main():
    try:
        raw_review_data = pd.read_csv('./combined_review_data.csv',keep_default_na=True,na_values=[""])
        raw_review_data = raw_review_data[[
            'product_id',
            'booking_review_score','booking_total_reviews',
            'hotels_review_score','hotels_total_reviews',
            'agoda_review_score','agoda_total_reviews',
            'expedia_review_score', 'expedia_total_reviews',
            'trip_review_score','trip_total_reviews'
        ]]
        with open('./grs_final_sheet.csv', 'a', newline='', encoding='utf-8') as csvfile:
            fieldnames = [
                'product_id',
                'grs',
                'total_reviews',
                'adjective',
                'booking_review_score',
                'booking_total_reviews',
                'hotels_review_score',
                'hotels_total_reviews',
                'agoda_review_score',
                'agoda_total_reviews',
                'expedia_review_score',
                'expedia_total_reviews',
                'trip_review_score',
                'trip_total_reviews'
            ]

            csv_writer = csv.DictWriter(csvfile, fieldnames=fieldnames)
            csv_writer.writeheader()

        for index,review_data in raw_review_data.iterrows():
            print("Product ID : "+str(review_data['product_id']))
            grs_review_score=0
            grs_review_count = 0
            total_reviews = 0

            booking_review_score = float(review_data['booking_review_score']) if not isNaN(review_data['booking_review_score']) else 0
            booking_review_score = round((booking_review_score /2),1)
            if booking_review_score > 0:
                grs_review_score = grs_review_score+booking_review_score
                grs_review_count = grs_review_count+1
                total_reviews = total_reviews + int(review_data['booking_total_reviews'])



            hotels_review_score = float(review_data['hotels_review_score']) if not isNaN(review_data['hotels_review_score']) else 0
            hotels_review_score = hotels_review_score/2
            if hotels_review_score > 0:
                grs_review_score = grs_review_score+hotels_review_score
                grs_review_count = grs_review_count+1
                total_reviews = total_reviews + int(review_data['hotels_total_reviews'])

            agoda_review_score = float(review_data['agoda_review_score']) if not isNaN(review_data['agoda_review_score']) else 0
            agoda_review_score = agoda_review_score/2
            if agoda_review_score > 0:
                grs_review_score = grs_review_score + agoda_review_score
                grs_review_count = grs_review_count + 1
                total_reviews = total_reviews + int(review_data['agoda_total_reviews'])


            expedia_review_score = float(review_data['expedia_review_score']) if not isNaN(review_data['expedia_review_score']) else 0
            if expedia_review_score > 0:
                grs_review_score = grs_review_score + expedia_review_score
                grs_review_count = grs_review_count + 1
                expedia_total_reviews = str(review_data['expedia_total_reviews'])
                expedia_total_reviews = expedia_total_reviews.replace(",", '').replace('review', '').replace(' ','').strip()
                total_reviews = total_reviews + int(expedia_total_reviews)

            trip_review_score = float(review_data['trip_review_score']) if not isNaN(review_data['trip_review_score']) else 0
            if trip_review_score > 0:
                grs_review_score = grs_review_score + trip_review_score
                grs_review_count = grs_review_count + 1
                total_reviews = total_reviews + int(review_data['trip_total_reviews'])
            print(booking_review_score)
            print(hotels_review_score)
            print(agoda_review_score)
            print(expedia_review_score)
            print(trip_review_score)
            print("GRS total Review Score : "+str(grs_review_score))
            print("GRS reviews count : "+str(grs_review_count))

            if grs_review_count > 0 and total_reviews > 0:
                avg_grs_score = float(grs_review_score/grs_review_count)
                avg_grs_score = round(avg_grs_score,1)
                adjective = getReviewAdjectives(avg_grs_score)

                print("Avg GRS : "+str(avg_grs_score))
                print("Total Reviews : "+str(total_reviews))
                with open('./grs_final_sheet.csv','a',newline='',encoding='utf-8') as csvfile:
                    fieldnames = [
                        'product_id',
                        'grs',
                        'total_reviews',
                        'adjective',
                        'booking_review_score',
                        'booking_total_reviews',
                        'hotels_review_score',
                        'hotels_total_reviews',
                        'agoda_review_score',
                        'agoda_total_reviews',
                        'expedia_review_score',
                        'expedia_total_reviews',
                        'trip_review_score',
                        'trip_total_reviews'
                    ]

                    csv_writer = csv.DictWriter(csvfile,fieldnames=fieldnames)
                    csv_writer.writerow({
                        'product_id':review_data['product_id'],
                        'grs':avg_grs_score,
                        'total_reviews':total_reviews,
                        'adjective':adjective if not None else '',
                        'booking_review_score':booking_review_score,
                        'booking_total_reviews':review_data['booking_total_reviews'],
                        'hotels_review_score':hotels_review_score,
                        'hotels_total_reviews':review_data['hotels_total_reviews'],
                        'agoda_review_score':agoda_review_score,
                        'agoda_total_reviews':review_data['agoda_total_reviews'],
                        'expedia_review_score':expedia_review_score,
                        'expedia_total_reviews':review_data['expedia_total_reviews'],
                        'trip_review_score':trip_review_score,
                        'trip_total_reviews':review_data['trip_total_reviews']
                    })
    except Exception as ex:
        track= traceback.format_exc()

        print(track)

def getReviewAdjectives(avg_grs_score):
    adjective=None

    if avg_grs_score >=3 and avg_grs_score<3.5:
        adjective='OK'

    if avg_grs_score >=3.5 and avg_grs_score<4:
        adjective='Good'

    if avg_grs_score >=4 and avg_grs_score<4.5:
        adjective='Very Good'

    if avg_grs_score >=4.5 and avg_grs_score<5:
        adjective='Wonderful'

    if avg_grs_score ==5:
        adjective='Exceptional'

    return adjective



main()