from api.app.booking.booking_review_scrapper import *
from api.app.hotels.hotels_review_scrapper import *
from api.app.agoda.agoda_reviews_scrapper import *
from api.app.expedia.expedia_review_scrapper import *
from concurrent.futures.thread import ThreadPoolExecutor
from mysql.connector import Error
import mysql

db_connection= False
def dbConnect():
    try:
        connection = mysql.connector.connect(
            host = '127.0.0.1',
            user='guest',
            password ='admin@123',
            database= 'cn_grs'
        )
        return connection
    except Error as e:
        print(e)

def getTotalCityHotelsCount(city,state,country):

    connection  = dbConnect()
    
    query = "select count(*) from cn_grs.fc_product_hotel_reviews where (source = 'ratehawk' or source = 'ctrips' or source = 'lci' or source='rakuteen') and city LIKE \"%"+str(city)+"%\" and state=\""+str(state)+"\" and country = \""+str(country)+"\""
    print(query)
    cursor = connection.cursor(buffered=True)
    cursor.execute(query)
    total_count = cursor.fetchone()
    connection.close()
    total_count = total_count[0]
    return total_count
    # with connection.cursor(buffered=True) as cursor:
    #     cursor.execute(query)
    #     total_count = cursor.fetchone()
    #     connection.close()
    #     total_count = total_count[0]
    #     return total_count


def getCityHotelsFromDB(city,state,country):
    connection  = dbConnect()
    # query ="select * from cn_grs.fc_product_hotel_reviews where (source = 'ratehawk' or source = 'ctrips' or source = 'lci') and city in ('Las Vegas', 'London', 'Dubai', 'Amsterdam', 'Paris', 'Singapore', 'Barcelona', 'Bangkok', 'Prague', 'Hong Kong', 'Lisbon', 'Hollywood', 'Chicago', 'New Orleans', 'San Francisco', 'Orlando', 'Miami', 'Edinburgh', 'Dublin', 'Los Angeles', 'Boston', 'Washington DC', 'Rome', 'Jaipur', 'Tokyo', 'Seattle', 'Berlin', 'Delhi', 'Mumbai', 'Atlanta', 'Toronto', 'Philadelphia', 'Istanbul', 'Hamburg', 'Honolulu', 'Cape Town', 'Chennai', 'Dallas', 'Abu Dhabi', 'Vancouver', 'Venice', 'Budapest', 'Sydney', 'Vienna', 'Manila', 'Madrid', 'Houston', 'Colombo', 'Agra', 'Kuala Lumpur', 'New York', 'Brussels', 'Copenhagen', 'Pattaya', 'Munich', 'Athens', 'Melbourne', 'Santorini', 'Cairo', 'Iceland', 'Seoul', 'Milan', 'Florence', 'Stockholm', 'Johannesburg', 'Beirut', 'Cebu City', 'Kyoto', 'Auckland', 'Dubrovnik', 'Chiang Mai', 'Amman', 'Nice', 'Shanghai', 'Taipei', 'Mexico City', 'Boracay', 'Hanoi', 'Geneva', 'Osaka', 'Jerusalem', 'Moscow', 'Porto', 'Antalya', 'Hurghada', 'Rio de Janeiro', 'Costa Rica', 'Krabi', 'Split ', 'Ho Chi Minh City', 'Warsaw', 'Jakarta', 'Buenos Aires', 'Phnom Penh', 'Macau', 'Casablanca', 'Sofia', 'Johor Bahru', 'Zagreb', 'Shenzhen', 'Da Nang') order by city ASC limit "+str(limit)+" offset "+str(offset)
    query= "select * from cn_grs.fc_product_hotel_reviews where (source = 'ratehawk' or source = 'ctrips' or source = 'lci' or source='rakuteen') and city LIKE \"%"+str(city)+"%\" and state=\""+str(state)+"\" and country = \""+str(country)+"\""
    cursor = connection.cursor(buffered=True) 
    cursor.execute(query)
    results = cursor.fetchall()
    connection.close()
    return results
    # with connection.cursor(buffered=True) as cursor:
    #     cursor.execute(query)
    #     results = cursor.fetchall()
    #     connection.close()
    #     return results
        

def isNaN(string):
    return string != string

# Yield successive n-sized 
# chunks from l. 
def divide_chunks(l, n): 
      
    # looping till length l 
    for i in range(0, len(l), n):  
        yield l[i:i + n] 

def main():

    top_cities = pd.read_csv('./grs_matched_finalized.csv')
    total_hotels_count = 0
    threads = list()
    executor = ThreadPoolExecutor(max_workers=4)
    for index,top_city in top_cities.iterrows():
        city = top_city['CITY']
        city = city.strip()
        print(city)
        if not isNaN(top_city['STATE']):
            state = top_city['STATE']
        else:
            state = ''
        
        print(state)
        country = top_city['COUNTRY']

        print(country)
        total_city_hotel_count = getTotalCityHotelsCount(city,state,country)
        if total_city_hotel_count > 0:    
            hotels= getCityHotelsFromDB(city,state,country)
            for hotel in hotels:
                thread_count=0        
                cn_property_id = hotel[0] 
                print("Property Id : "+str(cn_property_id))

                cn_hotel_name = hotel[2]
                print("Hotel Name : "+cn_hotel_name)
                city_name = hotel[6]
                print("City Name : "+city_name)
                cn_latitude = float(hotel[3])   
                cn_longitude = float(hotel[4])
                
                print("Latitude : "+str(cn_latitude))
                print("Longitude : "+str(cn_longitude))

                # getReviewFromBooking(cn_property_id,cn_hotel_name,city_name,cn_latitude,cn_longitude,False)
                # getReviewsFromHotels(cn_property_id,cn_hotel_name,city_name,cn_latitude,cn_longitude,False)
                # getReviewsFromAgoda(cn_property_id,cn_hotel_name,city_name,cn_latitude,cn_longitude,False)
                # getReviewsFromExpedia(cn_property_id,cn_hotel_name,city_name,cn_latitude,cn_longitude,False)
                
                
                threads.append(executor.submit(getReviewFromBooking,cn_property_id,cn_hotel_name,city_name,cn_latitude,cn_longitude,False))
                threads.append(executor.submit(getReviewsFromHotels,cn_property_id,cn_hotel_name,city_name,cn_latitude,cn_longitude,False))
                threads.append(executor.submit(getReviewsFromAgoda,cn_property_id,cn_hotel_name,city_name,cn_latitude,cn_longitude,False))
                threads.append(executor.submit(getReviewsFromExpedia,cn_property_id,cn_hotel_name,city_name,cn_latitude,cn_longitude,False))
                
                # for thread in futures.as_completed(threads):
                #     thread_count = thread_count+1
                #     print("Thread Count : "+str(thread_count))
        
                    


main()
