import pandas as pd
import csv
from pandas import DataFrame
import  math


def isNan(string):
    return  string!=string

def main():
    top_hotels_list = pd.read_csv('./top_hotels_200_phase_2.csv')

    booking_review_data = pd.read_csv('./booking_review_data.csv',keep_default_na=False,na_values=[""])
    booking_review_data.drop_duplicates(subset=['product_id'], keep="first", inplace=True)

    hotel_review_data = pd.read_csv('./hotels_review_data.csv',keep_default_na=False,na_values=[""])
    hotel_review_data.drop_duplicates(subset=['product_id'],keep="last",inplace=True)

    agoda_review_data=pd.read_csv('./agoda_review_data.csv',keep_default_na=False,na_values=[""])
    agoda_review_data.drop_duplicates(subset=['product_id'], keep="last", inplace=True)

    expedia_review_data = pd.read_csv('./expedia_review_data.csv',keep_default_na=False,na_values=[""])
    expedia_review_data.drop_duplicates(subset=['product_id'], keep="last", inplace=True)

    trip_review_data = pd.read_csv('./trip_review_data.csv',keep_default_na=False,na_values=[""])
    trip_review_data.drop_duplicates(subset=['product_id'], keep="last", inplace=True)

    for index,row in top_hotels_list.iterrows():
        hotel_review_found = False
        base_product_id = row['product_id']
        booking_review_score = 0.0
        booking_total_reviews = 0
        # check if product id exists in booking
        booking_row = booking_review_data[booking_review_data['product_id'] == base_product_id]
        # print(booking_row)
        if len(booking_row) > 0:
            hotel_review_found = True
            booking_row = booking_row.values.tolist()
            booking_row = booking_row[0]

            booking_review_score = booking_row[2]
            booking_total_reviews = booking_row[4]
            print("Booking Score : "+str(booking_review_score))
            print("Booking Total Reviews : "+str(booking_total_reviews))

        hotels_review_score = 0.0
        hotels_total_reviews = 0

        # check if product id exists in booking
        hotels_row = hotel_review_data[hotel_review_data['product_id'] == base_product_id]

        if len(hotels_row) > 0:
            hotel_review_found = True
            hotels_row = hotels_row.values.tolist()
            hotels_row = hotels_row[0]
            hotels_review_score = hotels_row[2]
            if hotels_review_score > 10:
                hotels_review_score = hotels_review_score/10
            hotels_total_reviews = hotels_row[4]
            print("Hotels Score : " + str(hotels_review_score))
            print("Hotels Reviews : " + str(hotels_total_reviews))

        agoda_review_score = 0.0
        agoda_total_reviews = 0

        # check if product id exists in booking
        agoda_row = agoda_review_data[agoda_review_data['product_id'] == base_product_id]

        if len(agoda_row) > 0:
            hotel_review_found = True
            agoda_row = agoda_row.values.tolist()
            agoda_row = agoda_row[0]
            if len(str(agoda_row[2])) > 0 and len(str(agoda_row[4])) > 0:
                if agoda_row[2] is not None and agoda_row[4] is not None:
                    if agoda_row[2] != 'nan' and agoda_row[4] != 'nan':
                        agoda_review_score = agoda_row[2]
                        agoda_total_reviews = agoda_row[4]
                        print("Agoda Score : " + str(agoda_review_score))
                        print("Agoda Reviews : " + str(agoda_total_reviews))

        trip_review_score=0.0
        trip_total_reviews = 0
        trip_row = trip_review_data[trip_review_data['product_id'] == base_product_id]
        if len(trip_row) > 0:
            hotel_review_found = True
            trip_row = trip_row.values.tolist()
            trip_row = trip_row[0]

            trip_review_score = trip_row[2]
            trip_total_reviews = trip_row[4]
            print("Trip Score : " + str(trip_review_score))
            print("Trip Reviews : " + str(trip_total_reviews))


        expedia_review_score = 0.0
        expedia_total_reviews=0
        expedia_row = expedia_review_data[expedia_review_data['product_id'] == base_product_id]
        if len(expedia_row) > 0:

            hotel_review_found = True
            expedia_row = expedia_row.values.tolist()
            expedia_row = expedia_row[0]

            expedia_review_score = expedia_row[1]
            expedia_total_reviews = expedia_row[2]
            print("Expedia Score : " + str(expedia_review_score))
            print("Expedia Reviews : " + str(expedia_total_reviews))
        if hotel_review_found:
            with open('./combined_review_data.csv','a',newline='') as csvfile:
                fieldnames=[
                    'product_id',
                    'booking_review_score',
                    'booking_total_reviews',
                    'hotels_review_score',
                    'hotels_total_reviews',
                    'agoda_review_score',
                    'agoda_total_reviews',
                    'trip_review_score',
                    'trip_total_reviews',
                    'expedia_review_score',
                    'expedia_total_reviews',
                ]
                writer = csv.DictWriter(csvfile,fieldnames=fieldnames)
                writer.writerow({
                    'product_id':base_product_id,
                    'booking_review_score':booking_review_score,
                    'booking_total_reviews':booking_total_reviews,
                    'hotels_review_score':hotels_review_score,
                    'hotels_total_reviews':hotels_total_reviews,
                    'agoda_review_score':agoda_review_score,
                    'agoda_total_reviews':agoda_total_reviews,
                    'trip_review_score':trip_review_score,
                    'trip_total_reviews':trip_total_reviews,
                    'expedia_review_score':expedia_review_score,
                    'expedia_total_reviews':expedia_total_reviews,
                })
    print('File complete')

main()